<?php

$portstr = "";

//Function to collect a port name from a numeric string ID
function ParsePort($id)
{
 	global $portstr;

	$portstr = "PORT?";
	if (strcmp($id, "1048576") == 0)
		$portstr = "PORTA";
	if (strcmp($id, "1048577") == 0)
		$portstr = "PORTB";
	if (strcmp($id, "1048578") == 0)
		$portstr = "PORTC";
	if (strcmp($id, "1048579") == 0)
		$portstr = "PORTD";
	if (strcmp($id, "1048580") == 0)
		$portstr = "PORTE";
	if (strcmp($id, "1048581") == 0)
		$portstr = "PORTF";
	if (strcmp($id, "1048582") == 0)
		$portstr = "PORTG";
	if (strcmp($id, "1048583") == 0)
		$portstr = "PORTH";
	if (strcmp($id, "1048584") == 0)
		$portstr = "PORTI";
	if (strcmp($id, "1048595") == 0)
		$portstr = "PORTJ";
}


$xlabeloffset = 50;
$ylabeloffset = 14;



//Function to print a string while tracking the length and ensuring there is enough X space to accomodate without overdrawing
//Most print functions now go via this function to ensure correct spacing everywhere
function StringPrintAutoLength($text, $x, $y, $bmax)
{
	global $script, $macroidx;

	$bmx = $bmax;

	//If the data contains string literals then they are being converted to " which is breaking code generation replaced with 2 x '
	$outstr = str_replace("\"", "\'\'", $text);

	$length = strlen($outstr);
	if ($length > 15)
	{
		$temp = (($length - 15) * 6) + $x;
		if ($temp > $bmx)
			$bmx = $temp;
	}

	$script[$macroidx] .= "ctx.fillText(\"".$outstr."\", ".$x.", ".$y.");\n\t";
	return $bmx;
}




//Function to split a multiline string fragment up into several draw functions while maintaining the flowline
//Does not seem to be working -= PHP function could be removing \n characters?
function ParseMultiline($data)
{
	global $xcoord, $ycoord, $xlabeloffset, $ylabeloffset, $script, $macroidx;

	$xstrpixlen = $xcoord[$macroidx];
	$yst = $ycoord[$macroidx];

	$lines = explode("\n", $data);
	foreach($lines as $line)
	{
		$xstrpixlen = StringPrintAutoLength($line, ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 20), $xstrpixlen);
		$ycoord[$macroidx] += 15;
	}

	while(($ycoord[$macroidx] - $yst) > 30)
	{
		$script[$macroidx] .= "ctx.drawImage(spacer, ".($xcoord[$macroidx] + 46).", ".($ycoord[$macroidx]+58).");\n\t";
		$ycoord[$macroidx] += 5;
		$yst += 30;
	}

	return $xstrpixlen;
}



//Function to split a multiline exp fragment up into several draw functions while maintaining the flowline
function ParseMultiExp($data)
{
	global $xcoord, $ycoord, $xlabeloffset, $ylabeloffset, $script, $macroidx;

	$xstrpixlen = $xcoord[$macroidx];
	$yst = $ycoord[$macroidx];

	foreach($data->children() as $expression)
	{
		$xstrpixlen = StringPrintAutoLength($expression['exp'], ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 20), $xstrpixlen);
		$ycoord[$macroidx] += 15;
	}

	while(($ycoord[$macroidx] - $yst) > 30)
	{
		$script[$macroidx] .= "ctx.drawImage(spacer, ".($xcoord[$macroidx] + 46).", ".($yst + 58).");\n\t";
		$ycoord[$macroidx] += 5;
		$yst += 30;
	}

	return $xstrpixlen;
}


//Function to split a multiline exp fragment up into a macro call parameters and returns xxx = macroidx (param1, param2, ...)
function ParseMultiExp2($data, $macro)
{
	global $xcoord, $ycoord, $xlabeloffset, $ylabeloffset, $script, $macroidx;

	$xstrpixlen = $xcoord[$macroidx];
	$skip = 0;
	$first = 1;
	$outstr = "";

	if ($data->return['exp'])
	{
		$outstr = $data->return['exp']." = ";
		$skip = 1;
	}

	$outstr .= $macro;
	$outstr2 = " ( ";
	foreach($data->children() as $expression)
	{
		if($skip > 0)
		{
			$skip--;
		}
		else
		{
			if($first > 0)
			{
				$outstr2 .= $expression['exp'];
				$first = 0;
			}
			else
			{
				$outstr2 .= ", " . $expression['exp'];
			}
		}
	}

	$outstr2 .= " )";

	$xstrpixlen = StringPrintAutoLength($outstr, ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 20), $xstrpixlen);
	$xstrpixlen = StringPrintAutoLength($outstr2, ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 35), $xstrpixlen);

	return $xstrpixlen;
}



//Recursive Function takes an XML object and incrementally builds up the script variable based on the current item,
//for nested items (loops, decisions etc) we step inside the current object and call the function again to continue parsing inside the object

function ParseXML($ico)
{
	global $xcoord, $ycoord, $xlabeloffset, $ylabeloffset, $script, $portstr, $maxx, $macroidx, $disflag;

	//Maximum X defines the largest branch in the macro and hence the X size of canvas
	if ($xcoord[$macroidx] > $maxx[$macroidx])
		$maxx[$macroidx] = $xcoord[$macroidx];

	//Branch Max X defines the largest branch in the current tree next rhs branch coordinates - local to this instance of the macro
	$branchmaxx = $xcoord[$macroidx];

	if ( strcmp($ico['class_type'], "input") == 0 )
	{
		//Draw icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
			$script[$macroidx] .= "ctx.drawImage(inputd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		else
			$script[$macroidx] .= "ctx.drawImage(input, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);
		ParsePort($ico['port']);
		$script[$macroidx] .= "ctx.fillText(\"".$portstr." -> ".$ico['exp']."\", ".($xcoord[$macroidx] + $xlabeloffset + 40).", ".($ycoord[$macroidx] + $ylabeloffset + 20).");\n\t";
		$ycoord[$macroidx] += 58;
	}

	if ( strcmp($ico['class_type'], "output") == 0 )
	{
		//Draw icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
			$script[$macroidx] .= "ctx.drawImage(outputd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		else
			$script[$macroidx] .= "ctx.drawImage(output, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);
		ParsePort($ico['port']);
		$script[$macroidx] .= "ctx.fillText(\"".$ico['exp']." -> ".$portstr."\", ".($xcoord[$macroidx] + $xlabeloffset + 40).", ".($ycoord[$macroidx] + $ylabeloffset + 20).");\n\t";
		$ycoord[$macroidx] += 58;
	}

	if ( strcmp($ico['class_type'], "delay") == 0 )
	{
		//Draw icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
			$script[$macroidx] .= "ctx.drawImage(delayd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		else
			$script[$macroidx] .= "ctx.drawImage(delay, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);

		if ( strcmp($ico['type'], "0") == 0 )
			$script[$macroidx] .= "ctx.fillText(\"".$ico['exp']." us\", ".($xcoord[$macroidx] + $xlabeloffset + 40).", ".($ycoord[$macroidx] + $ylabeloffset + 20).");\n\t";
		if ( strcmp($ico['type'], "1") == 0 )
			$script[$macroidx] .= "ctx.fillText(\"".$ico['exp']." ms\", ".($xcoord[$macroidx] + $xlabeloffset + 40).", ".($ycoord[$macroidx] + $ylabeloffset + 20).");\n\t";
		if ( strcmp($ico['type'], "2") == 0 )
			$script[$macroidx] .= "ctx.fillText(\"".$ico['exp']." s\", ".($xcoord[$macroidx] + $xlabeloffset + 40).", ".($ycoord[$macroidx] + $ylabeloffset + 20).");\n\t";

		$ycoord[$macroidx] += 58;
	}

	if ( strcmp($ico['class_type'], "decision") == 0 )
	{
		//Draw icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
		{
			$script[$macroidx] .= "ctx.drawImage(decisiond, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			$disflag++;
		}
		else
			$script[$macroidx] .= "ctx.drawImage(decision, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";

		$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);

		//Record required decision code length but do not let this effect the next RHS branch
		$branchmaxx2 = StringPrintAutoLength("if ".$ico['exp']." ?", ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 20), $branchmaxx);

		if ( strcmp($ico['swap'], "0") == 0 )
			$script[$macroidx] .= "ctx.fillText(\"Yes\", ".($xcoord[$macroidx] + $xlabeloffset + 40).", ".($ycoord[$macroidx] + $ylabeloffset + 45).");\n\t";
		else
			$script[$macroidx] .= "ctx.fillText(\"No\", ".($xcoord[$macroidx] + $xlabeloffset + 40).", ".($ycoord[$macroidx] + $ylabeloffset + 45).");\n\t";

		$ycoord[$macroidx] += 82;
		$ystart = $ycoord[$macroidx];

		//Loop through LHS branch - Usually no
		foreach($ico->flowline[1]->children() as $icon)
		{
			$test = ParseXML($icon);
			if ($test > $branchmaxx)
				$branchmaxx = $test;
		}

		$LHSXcoord = $xcoord[$macroidx];
		$LHSYcoord = $ycoord[$macroidx];

		if ($ycoord[$macroidx] > $ystart)
			$RHSXcoord = $branchmaxx + 200;
		else
			$RHSXcoord = $branchmaxx + 150;

		$ycoord[$macroidx] = $ystart;
		$xcoord[$macroidx] += 150;

		//Top Line
		while ($xcoord[$macroidx] < $RHSXcoord)
		{
			$script[$macroidx] .= "ctx.drawImage(hspacer, ".($xcoord[$macroidx]).", ".($ycoord[$macroidx] - 44).");\n\t";
			$xcoord[$macroidx] = $xcoord[$macroidx] + 50;
		}

		$xcoord[$macroidx] = $RHSXcoord;

		//Top Corner
		$script[$macroidx] .= "ctx.drawImage(corner1, ".($xcoord[$macroidx]).", ".($ycoord[$macroidx] - 44).");\n\t";

		$xcoord[$macroidx] -= 3;

		$script[$macroidx] .= "ctx.drawImage(spacer, ".($xcoord[$macroidx] + 46).", ".($ycoord[$macroidx] - 35).");\n\t";

		$branchmaxx = $xcoord[$macroidx];

		//Contents
		foreach($ico->flowline[0]->children() as $icon)
		{
			$test = ParseXML($icon);
			if ($test > $branchmaxx)
				$branchmaxx = $test;
		}

		$RHSYcoord = $ycoord[$macroidx];

		//Maximum X defines the largest branch in the macro and hence the X size of canvas
		if ($branchmaxx > $maxx[$macroidx])
			$maxx[$macroidx] = $branchmaxx;

		//Fill Vertical spaces
		if ($LHSYcoord > $RHSYcoord)
		{
			while($LHSYcoord > ($RHSYcoord + 10))
			{
				$script[$macroidx] .= "ctx.drawImage(spacer, ".($RHSXcoord + 43).", ".$RHSYcoord.");\n\t";
				$RHSYcoord += 50;
			}

			$ycoord[$macroidx] = $LHSYcoord;
		}

		else if ($LHSYcoord < $RHSYcoord)
		{
			while(($LHSYcoord + 10) < $RHSYcoord)
			{
				$script[$macroidx] .= "ctx.drawImage(spacer, ".($LHSXcoord + 46).", ".$LHSYcoord.");\n\t";
				$LHSYcoord += 50;
			}

			$ycoord[$macroidx] = $RHSYcoord;
		}

		//Bottom Corner
		$script[$macroidx] .= "ctx.drawImage(corner2, ".($RHSXcoord).", ".($ycoord[$macroidx] ).");\n\t";

		//Bottom Line
		$xcoord[$macroidx] -= 30;
		while ($xcoord[$macroidx] > $LHSXcoord)
		{
			$script[$macroidx] .= "ctx.drawImage(hspacer, ".($xcoord[$macroidx]).", ".($ycoord[$macroidx] + 13).");\n\t";
			$xcoord[$macroidx] -= 50;
		}

		$xcoord[$macroidx] = $LHSXcoord;

		//Draw ending icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
		{
			$script[$macroidx] .= "ctx.drawImage(decisionendd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			$disflag--;
		}
		else
			$script[$macroidx] .= "ctx.drawImage(decisionend, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		$ycoord[$macroidx] += 41;

		//If decision code is long then increase X spacing.
		if ($branchmaxx2 > $branchmaxx)
		{
			$branchmaxx = $branchmaxx2;
		}

	}

	if ( strcmp($ico['class_type'], "switch") == 0 )
	{
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
		{
			$script[$macroidx] .= "ctx.drawImage(decisiond, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			$disflag++;
		}
		else
			$script[$macroidx] .= "ctx.drawImage(decision, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";

		$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);

		//Record required decision code length but do not let this effect the next RHS branch
		$branchmaxx2 = StringPrintAutoLength("switch ".$ico['exp'], ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 20), $branchmaxx);
		$ycoord[$macroidx] += 82;

		$CaseXcoord = array();
		$CaseYcoord = array();

		$ystart = $ycoord[$macroidx];
		$CaseXcoord[0] = $xcoord[$macroidx];

		$childcount = $ico->count();
		$idx = 0;
		while($idx < $childcount)
		{
			$ic = $ico->case[$idx]->flowline;
			$temp = $ico->case[$idx];

			//Loop through LHS branch - Usually no
			foreach($ic->children() as $icon)
			{
				$test = ParseXML($icon);
				if ($test > $branchmaxx)
					$branchmaxx = $test;
			}

			if ($ycoord[$macroidx] > $ystart)
				$CaseXcoord[$idx + 1] = $branchmaxx + 200;
			else
				$CaseXcoord[$idx + 1] = $branchmaxx + 150;
			$CaseYcoord[$idx] = $ycoord[$macroidx];

			if ($idx)
				$branchmaxx = StringPrintAutoLength("=".$temp['exp'], ($CaseXcoord[$idx] + 50), ($ystart - 15), $branchmaxx);

			$ycoord[$macroidx] = $ystart;
			if ($idx == 0)
				$xcoord[$macroidx] += 150;
			else
				$xcoord[$macroidx] += 56;

			if ($idx < ($childcount - 1))
			{
				//Top Line
				while ($xcoord[$macroidx] < $CaseXcoord[$idx + 1])
				{
					$script[$macroidx] .= "ctx.drawImage(hspacer, ".($xcoord[$macroidx]).", ".($ycoord[$macroidx] - 44).");\n\t";
					$xcoord[$macroidx] = $xcoord[$macroidx] + 50;
				}

				$xcoord[$macroidx] = $CaseXcoord[$idx + 1];

				//Top Corner
				if ($disflag)
					$script[$macroidx] .= "ctx.drawImage(switchtopd, ".($xcoord[$macroidx] - 40).", ".($ycoord[$macroidx] - 47).");\n\t";
				else
					$script[$macroidx] .= "ctx.drawImage(switchtop, ".($xcoord[$macroidx] - 40).", ".($ycoord[$macroidx] - 47).");\n\t";

				$xcoord[$macroidx] -= 3;

				$script[$macroidx] .= "ctx.drawImage(spacer, ".($xcoord[$macroidx] + 46).", ".($ycoord[$macroidx] - 15).");\n\t";
			}

			$branchmaxx = $xcoord[$macroidx];

			$idx++;
		}

		$maxy = max($CaseYcoord);

		$idx = 0;
		while($idx < $childcount)
		{
			//Fill Vertical spaces
			if ($CaseYcoord[$idx]< $maxy)
			{
				while(($CaseYcoord[$idx] + 35) < $maxy)
				{
					if ($idx == 0)
						$script[$macroidx] .= "ctx.drawImage(spacer, ".($CaseXcoord[$idx] + 46).", ".$CaseYcoord[$idx].");\n\t";
					else
						$script[$macroidx] .= "ctx.drawImage(spacer, ".($CaseXcoord[$idx] + 43).", ".$CaseYcoord[$idx].");\n\t";
					$CaseYcoord[$idx] += 10;
				}

				$ycoord[$macroidx] = $maxy;
			}

			if ($idx < ($childcount - 1))
			{
				//Bottom Line
				$xcoord[$macroidx] -= 60;
				while ($xcoord[$macroidx] > $CaseXcoord[$idx])
				{
					$script[$macroidx] .= "ctx.drawImage(hspacer, ".($xcoord[$macroidx]).", ".($ycoord[$macroidx] + 13).");\n\t";
					$xcoord[$macroidx] -= 50;
				}

				//Bottom Corner
				$script[$macroidx] .= "ctx.drawImage(corner2, ".($CaseXcoord[$idx + 1]).", ".($ycoord[$macroidx] ).");\n\t";
			}

			$idx++;
		}


		//Maximum X defines the largest branch in the macro and hence the X size of canvas
		if ($branchmaxx > $maxx[$macroidx])
			$maxx[$macroidx] = $branchmaxx;

		$xcoord[$macroidx] = $CaseXcoord[0];

		//Draw ending icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
		{
			$script[$macroidx] .= "ctx.drawImage(decisionendd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			$disflag--;
		}
		else
			$script[$macroidx] .= "ctx.drawImage(decisionend, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		$ycoord[$macroidx] += 41;

		//If decision code is long then increase X spacing.
		if ($branchmaxx2 > $branchmaxx)
		{
			$branchmaxx = $branchmaxx2;
		}

	}

	if ( strcmp($ico['class_type'], "label") == 0 )
	{
		//Draw icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
			$script[$macroidx] .= "ctx.drawImage(connectionpointd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		else
			$script[$macroidx] .= "ctx.drawImage(connectionpoint, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);
		$branchmaxx = StringPrintAutoLength($ico['labelid'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset + 20), $branchmaxx);
		$ycoord[$macroidx] += 58;
	}

	if ( strcmp($ico['class_type'], "goto") == 0 )
	{
		//Draw icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
			$script[$macroidx] .= "ctx.drawImage(gotod, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		else
			$script[$macroidx] .= "ctx.drawImage(goto, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);
		$branchmaxx = StringPrintAutoLength($ico['labelid'], ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 20), $branchmaxx);
		$ycoord[$macroidx] += 58;
	}

	if ( strcmp($ico['class_type'], "loop") == 0 )
	{
		//Draw icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
		{
			$script[$macroidx] .= "ctx.drawImage(loopd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			$disflag++;
		}
		else
			$script[$macroidx] .= "ctx.drawImage(loop, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);

		if (strcmp($ico['start'], "0") != 0)
		{
			if (strcmp($ico['type'], "0") == 0)
				$branchmaxx = StringPrintAutoLength("While ".$ico['exp'], ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 15), $branchmaxx);
			if (strcmp($ico['type'], "1") == 0)
				$branchmaxx = StringPrintAutoLength("Until ".$ico['exp'], ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 15), $branchmaxx);
		}

		if (strcmp($ico['type'], "2") == 0)
		{
			if (strcmp($ico['forvar'], "") == 0)
				$branchmaxx = StringPrintAutoLength("Loop ".$ico['exp']." times", ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 15), $branchmaxx);
			else
				$branchmaxx = StringPrintAutoLength("Loop ".$ico['forvar']." ".$ico['exp']." times", ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 15), $branchmaxx);
		}


		$ycoord[$macroidx] += 58;

		$xcoord[$macroidx] += 93;
		$branchmaxx = $xcoord[$macroidx];

		//Maximum X defines the largest branch in the macro and hence the X size of canvas
		if ($xcoord[$macroidx] > $maxx[$macroidx])
			$maxx[$macroidx] = $xcoord[$macroidx];

		foreach($ico->flowline[0]->children() as $icon)
		{
			$test = ParseXML($icon);
			if ($test > $branchmaxx)
				$branchmaxx = $test;
		}

		//Maximum X defines the largest branch in the macro and hence the X size of canvas
		if ($branchmaxx > $maxx[$macroidx])
			$maxx[$macroidx] = $branchmaxx;

		$ymax = $ycoord[$macroidx];
		$xcoord[$macroidx] -= 93;

		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
		{
			$script[$macroidx] .= "ctx.drawImage(loopendd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			$disflag--;
		}
		else
			$script[$macroidx] .= "ctx.drawImage(loopend, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";

		if (strcmp($ico['start'], "0") == 0)
		{
			if (strcmp($ico['type'], "0") == 0)
				$branchmaxx = StringPrintAutoLength("While ".$ico['exp'], ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 30), $branchmaxx);
			if (strcmp($ico['type'], "1") == 0)
				$branchmaxx = StringPrintAutoLength("Until ".$ico['exp'], ($xcoord[$macroidx] + $xlabeloffset + 40), ($ycoord[$macroidx] + $ylabeloffset + 30), $branchmaxx);
		}

		$ycoord[$macroidx] += 58;
	}

	if ( strcmp($ico['class_type'], "call") == 0 )
	{
		//Component Macro
		if ( !strcmp($ico['component'], "") == 0 )
		{
			//Draw icon or disabled version of icon
			if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
				$script[$macroidx] .= "ctx.drawImage(compmacrod, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			else
				$script[$macroidx] .= "ctx.drawImage(compmacro, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);

			$test = ParseMultiExp2($ico, $ico['component'].":".$ico['macro']);

			if ($test > $branchmaxx)
			{
				$branchmaxx = $test;

				//Maximum X defines the largest branch in the macro and hence the X size of canvas
				if ($branchmaxx > $maxx[$macroidx])
					$maxx[$macroidx] = $branchmaxx;
			}

			$ycoord[$macroidx] += 58;
		}

		//Standard Macro
		else
		{
			//Draw icon or disabled version of icon
			if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
				$script[$macroidx] .= "ctx.drawImage(macrod, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			else
				$script[$macroidx] .= "ctx.drawImage(macro, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);

			$test = ParseMultiExp2($ico, $ico['macro']);

			if ($test > $branchmaxx)
			{
				$branchmaxx = $test;

				//Maximum X defines the largest branch in the macro and hence the X size of canvas
				if ($branchmaxx > $maxx[$macroidx])
					$maxx[$macroidx] = $branchmaxx;
			}

			$ycoord[$macroidx] += 58;
		}
	}

	if ( strcmp($ico['class_type'], "calculation") == 0 )
	{
		//Draw icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
			$script[$macroidx] .= "ctx.drawImage(calcd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		else
			$script[$macroidx] .= "ctx.drawImage(calc, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);

		$yst = $ycoord[$macroidx];
		$test = ParseMultiExp($ico);

		if ($test > $branchmaxx)
		{
			$branchmaxx = $test;

			//Maximum X defines the largest branch in the macro and hence the X size of canvas
			if ($branchmaxx > $maxx[$macroidx])
				$maxx[$macroidx] = $branchmaxx;
		}

		//If comment isn't too large then don't add extra vertical spacing
		if ($ycoord[$macroidx] - $yst < 50)
			$ycoord[$macroidx] = $yst + 58;
		else
			$ycoord[$macroidx] += 30;
	}

	if ( strcmp($ico['class_type'], "native") == 0 )
	{
		//Draw icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
			$script[$macroidx] .= "ctx.drawImage(ccoded, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		else
			$script[$macroidx] .= "ctx.drawImage(ccode, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);

		$yst = $ycoord[$macroidx];
		$test = ParseMultiline($ico['ccode']);
		if ($test > $branchmaxx)
		{
			$branchmaxx = $test;

			//Maximum X defines the largest branch in the macro and hence the X size of canvas
			if ($branchmaxx > $maxx[$macroidx])
				$maxx[$macroidx] = $branchmaxx;
		}

		//If comment isn't too large then don't add extra vertical spacing
		if ($ycoord[$macroidx] - $yst < 50)
			$ycoord[$macroidx] = $yst;

		$ycoord[$macroidx] += 58;
	}

	if ( strcmp($ico['class_type'], "interrupt") == 0 )
	{
		//Draw icon or disabled version of icon
		if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
			$script[$macroidx] .= "ctx.drawImage(interruptd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		else
			$script[$macroidx] .= "ctx.drawImage(interrupt, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";

		$$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);

		if ( strcmp($ico['enable'], "1") == 0 )
			$script[$macroidx] .= "ctx.fillText(\"Enable \", ".($xcoord[$macroidx] + $xlabeloffset + 50).", ".($ycoord[$macroidx] + $ylabeloffset + 15).");\n\t";
		else
			$script[$macroidx] .= "ctx.fillText(\"Disable \", ".($xcoord[$macroidx] + $xlabeloffset + 50).", ".($ycoord[$macroidx] + $ylabeloffset + 15).");\n\t";

		$branchmaxx = StringPrintAutoLength($ico['name'], ($xcoord[$macroidx] + $xlabeloffset + 50), ($ycoord[$macroidx] + $ylabeloffset + 30), $branchmaxx);

		if ( strcmp($ico['call'], "") != 0 )
			$branchmaxx = StringPrintAutoLength("Call Macro ".$ico['call']."()", ($xcoord[$macroidx] + $xlabeloffset + 50), ($ycoord[$macroidx] + $ylabeloffset + 45), $branchmaxx);

		$ycoord[$macroidx] += 58;
	}

	if ( strcmp($ico['class_type'], "comment") == 0 )
	{
		//Draw icon or disabled version of icon
		$script[$macroidx] .= "ctx.drawImage(comment, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
		$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);

		$test = ParseMultiline($ico['comment']);
		if ($test > $branchmaxx)
		{
			$branchmaxx = $test;

			//Maximum X defines the largest branch in the macro and hence the X size of canvas
			if ($branchmaxx > $maxx[$macroidx])
				$maxx[$macroidx] = $branchmaxx;
		}

		$ycoord[$macroidx] += 38;
	}

	if ( strcmp($ico['class_type'], "sim") == 0 )
	{
		if ( !strcmp($ico['component'], "") == 0 )
		{
			//Draw icon or disabled version of icon
			if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
				$script[$macroidx] .= "ctx.drawImage(simd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			else
				$script[$macroidx] .= "ctx.drawImage(sim, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);
			$test = ParseMultiExp2($ico, $ico['component'].":".$ico['macro']);

			if ($test > $branchmaxx)
			{
				$branchmaxx = $test;

				//Maximum X defines the largest branch in the macro and hence the X size of canvas
				if ($branchmaxx > $maxx[$macroidx])
					$maxx[$macroidx] = $branchmaxx;
			}

			$ycoord[$macroidx] += 58;
		}
		else
		{
			//Draw icon or disabled version of icon
			if ( ($disflag) || strcmp($ico['disable'], "1") == 0 )
				$script[$macroidx] .= "ctx.drawImage(simd, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			else
				$script[$macroidx] .= "ctx.drawImage(sim, ".$xcoord[$macroidx].", ".$ycoord[$macroidx].");\n\t";
			$branchmaxx = StringPrintAutoLength($ico['title'], ($xcoord[$macroidx] + $xlabeloffset), ($ycoord[$macroidx] + $ylabeloffset), $branchmaxx);
			$test = ParseMultiExp2($ico, $ico['macro']);

			if ($test > $branchmaxx)
			{
				$branchmaxx = $test;

				//Maximum X defines the largest branch in the macro and hence the X size of canvas
				if ($branchmaxx > $maxx[$macroidx])
					$maxx[$macroidx] = $branchmaxx;
			}

			$ycoord[$macroidx] += 58;
		}

	}

	return $branchmaxx;
}


function ParseVarTypes($variable)
{
	global $constants, $variables, $locals, $return;

	$str = "";

	if (strcmp($variable['type'], "v0") == 0)
		$str = "VOID ";
	if (strcmp($variable['type'], "u8") == 0)
		$str = "BYTE ";
	if (strcmp($variable['type'], "T8") == 0)
		$str = "STRING ";
	if (strcmp($variable['type'], "T8*") == 0)
		$str = "STRING ";
	if (strcmp($variable['type'], "b1") == 0)
		$str = "BOOL ";
	if (strcmp($variable['type'], "u16") == 0)
		$str = "UNSIGNED INT ";
	if (strcmp($variable['type'], "s16") == 0)
		$str = "SIGNED INT ";
	if (strcmp($variable['type'], "u32") == 0)
		$str = "UNSIGNED LONG ";
	if (strcmp($variable['type'], "s32") == 0)
		$str = "SIGNED LONG ";
	if (strcmp($variable['type'], "f32") == 0)
		$str = "FLOAT ";
	if (strcmp($variable['type'], "h32") == 0)
		$str = "HANDLE ";

	if ( strcmp($variable['name'], "Return") == 0 )
	{
		$return .= $str;
	}
	else if ( strcmp($variable->getName(), "local") == 0 )
	{
		$str .= $variable['name'] . "&nbsp;&nbsp;&nbsp;&nbsp;\n";
		$locals .= $str;
	}
	else
	{
		$str .= $variable['name'] . "&nbsp;&nbsp;&nbsp;&nbsp;\n";

		if (strcmp($variable['isconst'], "1") == 0)
			$constants .= $str;
		else
			$variables .= $str;
	}
}


function EchoMenu($xml)
{

	echo "\n\n<br /><br /><div>";
	$first = 1;

	foreach($xml->children() as $component)
	{
		if ($first)
		{
			$first = 0;
			echo "<a href=\"#" . $component->flowline['name'] . "\" >" . $component->flowline['name'] . "</a>";
		}
		else
		{
			echo "&nbsp;&nbsp;&nbsp;&nbsp;/&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"#" . $component->flowline['name'] . "\" >" . $component->flowline['name'] . "</a>";
		}
	}
	echo "</div>\n\n";
}


?>