<?php

//Includes
include("../../include/headerinfo.php");
include("../include/defines.php");
include("functions.php");

//SuperGlobals
$wiki_filename = (isset($_GET['wfile']) ? $_GET['wfile'] : null);

//Initialise our variables
$startx = 10;
$starty = 15;
$macroidx = 0;
$sumx = 0;
$filepath = '';

$macros = array();
$script = array();
$xcoord = array();
$ycoord = array();
$maxx = array();

//Handle WikiFile sent
if($wiki_filename) {
    $purl = parse_url($wiki_filename);
    $filepath = "../..".$purl['path'];
} else {
    $filepath = $_FILES['file']['tmp_name'];
}

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <title>Matrix - Flowcode 8 Features - Electronic Systems Design</title>
    <meta name="description" content="Matrix offers electronics, computer science and electrical training and programming solutions and kits including Flowcode, E-Blocks, Locktronics, MIAC, Electronics Workstation and ECIO ">
    <meta name="viewport" content="width=device-width, initial-scale=0.86, maximum-scale=3.0, minimum-scale=0.86">
    <?php include("../../include/new_meta.php"); ?>

    <link href="../css/fc8.css" rel="stylesheet" type="text/css">

    <script type="text/javascript" src="https://code.jquery.com/jquery-1.12.4.js"></script>
    <script type="text/javascript" src="../../js/bootstrap.min.js"></script>
    <style type="text/css">
        .fcv-device {
            color: #0078A6;
        }

        .fcv-consts {
            background-color: #343A40;
            color: #FFFFFF;
            padding: 20px;
        }

        .fcv-canvas {
            overflow: auto;
            max-height: 800px;
        }

        .fcv-params {
            margin: 20px 0;
        }
    </style>
</head>


<body>

<?php include("../../include/newtopbar.php"); ?>
<?php include("../include/fc_logo_bar.php"); ?>

<div class="container mar-bot-40">
    <h1 class="mar-top-20">Flowcode Project File Parser</h1>

    <?php if(!$wiki_filename) { ?>
        <form action="" method="post" accept-charset="utf-8" enctype="multipart/form-data" class="mar-top-20">
        <input type="file" name="file">
        <input type="submit" name="btn_submit" value="Upload File" />
        </form>
    <?php } ?>
    <?php

    //Parse File As XML
    $xmldata = simplexml_load_file($filepath) or die("Failed to load");

    //Collect Project Details
    echo '<h3 class="mar-top-40"><strong>Target Device:</strong> <span class="fcv-device">'.$xmldata->document['target'].'</span></h3>';

    $idx = 0;
    $variables = "";
    $constants = "";
    $first_nav = true;

    //Loop through Globals
    foreach($xmldata->document->components->component[0]->variables->children() as $variable)
    {
        ParseVarTypes($variable->def);
    }
    ?>

    <h3 class="mar-top-40 mar-bot-20">Constants</h3>
    <div class="fcv-consts">
        <?php echo $constants ?>
    </div>

    <h3 class="mar-both-40">Globals</h3>
    <div class="fcv-consts">
        <?php echo $variables ?>
    </div>

    <?php $xmlMenuData = $xmldata->document->components->component[0]->macros; ?>

    <ul class="nav nav-tabs mar-top-40" id="myTab" role="tablist">
        <?php foreach($xmldata->document->components->component[0]->macros->children() as $component) { ?>
            <?php if($first_nav == true) { $nav_type = "true"; } else { $nav_type = "false"; }; ?>
            <li class="nav-item">
                <a class="nav-link <?php if ($first_nav == true) { echo "active"; } ?>" id="<?php echo $component->flowline['name'] ?>-tab" data-toggle="tab" href="#<?php echo $component->flowline['name'] ?>-main" role="tab" aria-controls="<?php echo $component->flowline['name'] ?>-main" aria-selected="<?php echo $nav_type ?>"><?php echo $component->flowline['name'] ?></a>
            </li>
            <?php $first_nav = false; ?>
        <?php } ?>
    </ul>
    <div class="tab-content" id="myTabContent">
    <?php $first_nav = true; ?>
    <?php
    //Loop through Macros
    foreach($xmldata->document->components->component[0]->macros->children() as $component)
    {
        $locals = "";
        $variables = "";
        $return = "";
        $constants = "";

        //Collect and store Macro Name
        $macroidx = $idx++;
        array_push($macros, $component->flowline['name']);
        $name = $component->flowline['name'];

        //Init Vars
        $script[$macroidx] = "";
        $xcoord[$macroidx] = $startx;
        $ycoord[$macroidx] = $starty;
        $maxx[$macroidx] = $startx;
        $disflag = 0;

        //Start Icon
        $script[$macroidx] .= "ctx.drawImage(start, $xcoord[$macroidx], $ycoord[$macroidx]);\n\t";
        $ycoord[$macroidx] += 58;

        //Loop through icons - Perform recursive sweep through macros and variables
        foreach($component->flowline->children() as $icon)
        {
            if (strcmp($icon['isinit'], "") != 0)
                ParseVarTypes($icon);
            else
                ParseXML($icon);
        }

        //End Icon
        $script[$macroidx] .= "ctx.drawImage(end, $xcoord[$macroidx], $ycoord[$macroidx]);\n";
        $ycoord[$macroidx] += 58;

        //Final Spacer
        $ycoord[$macroidx] += 10;

        //EchoMenu($xmlMenuData);

        ?>
        <div class="tab-pane fade <?php if ($first_nav == true) { echo "show active"; } ?>" id="<?php echo $component->flowline['name'] ?>-main" role="tabpanel" aria-labelledby="<?php echo $component->flowline['name'] ?>-tab">
            <h4 class="mar-top-20">Return: &nbsp;&nbsp;&nbsp;&nbsp;<span class="fcv-device"><?php echo $return ?></span></h4>
            <hr />
            <?php if ($variables) { ?>
                <h4 class="mar-top-20">Params:</h4>
                <div class="fcv-params">
                    <?php echo $variables ?>
                </div>
                <hr />
            <?php } ?>
            <?php if ($locals) { ?>
                <h4 class="mar-top-20">Vars:</h4>
                <div class="fcv-params">
                    <?php echo $locals ?>
                </div>
                <hr />
            <?php } ?>
            <h4 class="mar-both-20">Flowchart</h4>
            <div class="fcv-canvas">
                <canvas id="<?php echo $name; ?>" width="<?php echo ($maxx[$macroidx] + 400); ?>" height="<?php echo $ycoord[$macroidx]; ?>" style="border:1px solid #000000">Your browser does not support the HTML5 canvas tag.</canvas>
            </div>
        </div>
        <?php $first_nav = false; ?>
    <?php } ?>
    </div>

     <div id="icons" hidden>
         <img id="start" width="94" height="58" src="icons/start.png" alt="start icon">
         <img id="end" width="94" height="58" src="icons/end.png" alt="end icon">

         <img id="calc" width="94" height="58" src="icons/calc.png" alt="calculation icon">
         <img id="ccode" width="94" height="58" src="icons/ccode.png" alt="c code icon">
         <img id="comment" width="94" height="58" src="icons/comment.png" alt="comment icon">
         <img id="macro" width="94" height="58" src="icons/macro.png" alt="macro icon">
         <img id="compmacro" width="94" height="58" src="icons/compmacro.png" alt="component macro icon">
         <img id="connectionpoint" width="94" height="58" src="icons/connectionpoint.png" alt="connection point icon">
         <img id="delay" width="94" height="58" src="icons/delay.png" alt="delay icon">
         <img id="goto" width="94" height="58" src="icons/goto.png" alt="goto icon">
         <img id="input" width="94" height="58" src="icons/input.png" alt="input icon">
         <img id="output" width="94" height="58" src="icons/output.png" alt="output icon">
         <img id="sim" width="94" height="58" src="icons/sim.png" alt="sim icon">
         <img id="decision" width="94" height="58" src="icons/decision.png" alt="decision icon">
         <img id="decisionend" width="94" height="58" src="icons/decisionend.png" alt="decision end icon">
         <img id="loop" width="94" height="58" src="icons/loopstart.png" alt="loop icon">
         <img id="loopend" width="94" height="58" src="icons/loopend.png" alt="loop end icon">
         <img id="interrupt" width="94" height="58" src="icons/interrupt.png" alt="interrupt icon">
         <img id="switchtop" width="92" height="52" src="icons/switchtop.png" alt="switch top node icon">

         <img id="calcd" width="94" height="58" src="icons/calcd.png" alt="disabled calculation icon">
         <img id="ccoded" width="94" height="58" src="icons/ccoded.png" alt="disabled c code icon">
         <img id="macrod" width="94" height="58" src="icons/macrod.png" alt="disabled macro icon">
         <img id="compmacrod" width="94" height="58" src="icons/compmacrod.png" alt="disabled component macro icon">
         <img id="connectionpointd" width="94" height="58" src="icons/connectionpointd.png" alt="disabled connection point icon">
         <img id="delayd" width="94" height="58" src="icons/delayd.png" alt="disabled delay icon">
         <img id="gotod" width="94" height="58" src="icons/gotod.png" alt="disabled goto icon">
         <img id="inputd" width="94" height="58" src="icons/inputd.png" alt="disabled input icon">
         <img id="outputd" width="94" height="58" src="icons/outputd.png" alt="disabled output icon">
         <img id="simd" width="94" height="58" src="icons/simd.png" alt="disabled sim icon">
         <img id="decisiond" width="94" height="58" src="icons/decisiond.png" alt="decision icon">
         <img id="decisionendd" width="94" height="58" src="icons/decisionendd.png" alt="disabled decision end icon">
         <img id="loopd" width="94" height="58" src="icons/loopstartd.png" alt="disabled loop icon">
         <img id="loopendd" width="94" height="58" src="icons/loopendd.png" alt="disabled loop end icon">
         <img id="interruptd" width="94" height="58" src="icons/interruptd.png" alt="disabled interrupt icon">
         <img id="switchtopd" width="92" height="52" src="icons/switchtopd.png" alt="disabled switch top node icon">

         <img id="spacer" width="4" height="58" src="icons/spacer.png" alt="spacer icon">
         <img id="hspacer" width="51" height="14" src="icons/hspacer.png" alt="horizontal spacer icon">
         <img id="corner1" width="51" height="14" src="icons/corner1.png" alt="corner1 icon">
         <img id="corner2" width="47" height="43" src="icons/corner2.png" alt="corner2 icon">
     </div>

     <script>
     window.onload = function()
     {	<?php
            $idx = 0;
            foreach($macros as $macro)
            {
                $macroidx = $idx++;
                echo "\n\tvar canvas = document.getElementById(\"".$macro."\");\n\t";
                echo "var ctx = canvas.getContext(\"2d\");\n\t";
                echo "ctx.font = \"12px Arial\";\n\t";
            ?>

        ctx.beginPath();
        ctx.rect(0, 0, <?php echo ($maxx[$macroidx] + 400); ?>, <?php echo $ycoord[$macroidx]; ?>);
        ctx.fillStyle = 'white';
        ctx.fill();
        ctx.fillStyle = 'black';
        ctx.fillText("<?php echo $macro; ?>", 1, 10);
        <?php echo $script[$macroidx];
           }
        ?>
     };
    </script>

</div>

<?php include("../../include/newfooter.php"); ?>

</body>
</html>